> For the complete documentation index, see [llms.txt](https://developer.vario-software.de/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.vario-software.de/api-reference/user-message.md).

# User Message

Manage user messages via the VARIO Cloud REST API, including sending, updating, marking as seen, deleting messages, and retrieving message counts.

the user message API

## PUT /cmn/users/{id}/messages/last\_read

> mark messages as seen

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"User Message","description":"the user message API"}],"servers":[{"url":"api.example.com"}],"paths":{"/cmn/users/{id}/messages/last_read":{"put":{"tags":["User Message"],"summary":"mark messages as seen","operationId":"putLastRead","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"integer","format":"int64"}},{"name":"lastRead","in":"query","required":true,"schema":{"type":"string","format":"date-time"}}],"responses":{"200":{"description":"OK"}}}}}}
```

## PUT /cmn/users/my/messages/last\_read

> mark current user messages as seen

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"User Message","description":"the user message API"}],"servers":[{"url":"api.example.com"}],"paths":{"/cmn/users/my/messages/last_read":{"put":{"tags":["User Message"],"summary":"mark current user messages as seen","operationId":"putMyLastRead","parameters":[{"name":"lastRead","in":"query","required":true,"schema":{"type":"string","format":"date-time"}}],"responses":{"200":{"description":"OK"}}}}}}
```

## PUT /cmn/users/me/messages/{id}

> update a message

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"User Message","description":"the user message API"}],"servers":[{"url":"api.example.com"}],"paths":{"/cmn/users/me/messages/{id}":{"put":{"tags":["User Message"],"summary":"update a message","operationId":"updateMessage","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"integer","format":"int64"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"}}},"required":true},"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/common-user-UserMessage"}}}}}}}},"components":{"schemas":{"core-api-LocalizeableMessage":{"description":"localizeable message","properties":{"messageCode":{"type":"string","description":"Internal unique identifier/key for this message"},"messageParameters":{"type":"object","additionalProperties":{"type":"object","description":"list of parameters to fill a formattable message"},"description":"list of parameters to fill a formattable message"},"formattedMessage":{"type":"string","description":"formatted message (default language)"}}},"common-user-UserMessage":{"description":"Message.","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"recipientRef":{"$ref":"#/components/schemas/core-api-ApiObjectReference"},"senderRef":{"$ref":"#/components/schemas/core-api-ApiObjectReference"},"senderBotAlias":{"type":"string","description":"Sender (bot name) when the sender was not a user.","readOnly":true},"sendTime":{"type":"string","format":"date-time","description":"Timestamp: sent.","readOnly":true},"updateTime":{"type":"string","format":"date-time","description":"Timestamp: the update time.","readOnly":true},"lastRead":{"type":"string","format":"date-time","description":"Timestamp: read.","readOnly":true},"state":{"type":"string","description":"Status.","enum":["SEEN","NOT_SEEN"],"readOnly":true},"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"priority":{"type":"string","description":"Message priority.","enum":["HIGH","NORMAL","LOW"],"readOnly":true}}},"core-api-MetaInfo":{"description":"MetaInformations for this Object","properties":{"createdAt":{"type":"string","format":"date-time","description":"Created At Timestamp","readOnly":true},"createdFrom":{"type":"string","description":"TenantUser-Identifier of the creator","readOnly":true},"updatedAt":{"type":"string","format":"date-time","description":"Last Updated AT Timestamp","readOnly":true},"updatedFrom":{"type":"string","description":"TenantUser-Identifier of most recent updater","readOnly":true}}},"core-api-ApiObjectReference":{"description":"Parent category.","properties":{"id":{"type":"string","description":"Identifier"},"label":{"type":"string","description":"a label","readOnly":true},"description":{"type":"string","description":"a short description","readOnly":true},"active":{"type":"boolean","description":"Active.","readOnly":true}},"required":["id"]}}}}
```

## DELETE /cmn/users/me/messages/{id}

> delete a message

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"User Message","description":"the user message API"}],"servers":[{"url":"api.example.com"}],"paths":{"/cmn/users/me/messages/{id}":{"delete":{"tags":["User Message"],"summary":"delete a message","operationId":"deleteMyMessage","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/core-api-OperationMessage"}}}}}}}},"components":{"schemas":{"core-api-OperationMessage":{"properties":{"context":{"type":"string","description":"message context"},"messageValue":{"type":"string","description":" message"}}}}}}
```

## POST /cmn/users/me/messages

> post a message

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"User Message","description":"the user message API"}],"servers":[{"url":"api.example.com"}],"paths":{"/cmn/users/me/messages":{"post":{"tags":["User Message"],"summary":"post a message","operationId":"postMessage","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/common-user-UserMessageCreateRequest"}}},"required":true},"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/common-user-UserMessage"}}}}}}}},"components":{"schemas":{"common-user-UserMessageCreateRequest":{"description":"Message envelope to send.","properties":{"recipientUserIds":{"type":"array","description":"Recipient users.","items":{"type":"integer","format":"int64","description":"Recipient users."}},"recipientGroupIds":{"type":"array","description":"Recipient user groups (resolved to users).","items":{"type":"integer","format":"int64","description":"Recipient user groups (resolved to users)."}},"senderBotAlias":{"type":"string","description":"Optionally a BotName as the sender. Only for internal apps and may only be used with empty userIds and groupIds."},"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"}},"required":["message"]},"core-api-LocalizeableMessage":{"description":"localizeable message","properties":{"messageCode":{"type":"string","description":"Internal unique identifier/key for this message"},"messageParameters":{"type":"object","additionalProperties":{"type":"object","description":"list of parameters to fill a formattable message"},"description":"list of parameters to fill a formattable message"},"formattedMessage":{"type":"string","description":"formatted message (default language)"}}},"common-user-UserMessage":{"description":"Message.","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"recipientRef":{"$ref":"#/components/schemas/core-api-ApiObjectReference"},"senderRef":{"$ref":"#/components/schemas/core-api-ApiObjectReference"},"senderBotAlias":{"type":"string","description":"Sender (bot name) when the sender was not a user.","readOnly":true},"sendTime":{"type":"string","format":"date-time","description":"Timestamp: sent.","readOnly":true},"updateTime":{"type":"string","format":"date-time","description":"Timestamp: the update time.","readOnly":true},"lastRead":{"type":"string","format":"date-time","description":"Timestamp: read.","readOnly":true},"state":{"type":"string","description":"Status.","enum":["SEEN","NOT_SEEN"],"readOnly":true},"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"},"priority":{"type":"string","description":"Message priority.","enum":["HIGH","NORMAL","LOW"],"readOnly":true}}},"core-api-MetaInfo":{"description":"MetaInformations for this Object","properties":{"createdAt":{"type":"string","format":"date-time","description":"Created At Timestamp","readOnly":true},"createdFrom":{"type":"string","description":"TenantUser-Identifier of the creator","readOnly":true},"updatedAt":{"type":"string","format":"date-time","description":"Last Updated AT Timestamp","readOnly":true},"updatedFrom":{"type":"string","description":"TenantUser-Identifier of most recent updater","readOnly":true}}},"core-api-ApiObjectReference":{"description":"Parent category.","properties":{"id":{"type":"string","description":"Identifier"},"label":{"type":"string","description":"a label","readOnly":true},"description":{"type":"string","description":"a short description","readOnly":true},"active":{"type":"boolean","description":"Active.","readOnly":true}},"required":["id"]}}}}
```

## GET /cmn/users/{id}/messages/count

> return message count for specific user

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"User Message","description":"the user message API"}],"servers":[{"url":"api.example.com"}],"paths":{"/cmn/users/{id}/messages/count":{"get":{"tags":["User Message"],"summary":"return message count for specific user","operationId":"getMessageCount","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"integer","format":"int64"}},{"name":"state","in":"query","required":false,"schema":{"type":"string","enum":["SEEN","NOT_SEEN"]}}],"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"type":"integer","format":"int64"}}}}}}}}}
```

## GET /cmn/users/me/messages/count

> return message count for user

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"User Message","description":"the user message API"}],"servers":[{"url":"api.example.com"}],"paths":{"/cmn/users/me/messages/count":{"get":{"tags":["User Message"],"summary":"return message count for user","operationId":"getMyMessageCount","parameters":[{"name":"state","in":"query","required":false,"schema":{"type":"string","enum":["SEEN","NOT_SEEN"]}}],"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"type":"integer","format":"int64"}}}}}}}}}
```

## DELETE /cmn/users/{userId}/messages/{id}

> delete a message

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"User Message","description":"the user message API"}],"servers":[{"url":"api.example.com"}],"paths":{"/cmn/users/{userId}/messages/{id}":{"delete":{"tags":["User Message"],"summary":"delete a message","operationId":"deleteMessage","parameters":[{"name":"userId","in":"path","required":true,"schema":{"type":"integer","format":"int64"}},{"name":"id","in":"path","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/core-api-OperationMessage"}}}}}}}},"components":{"schemas":{"core-api-OperationMessage":{"properties":{"context":{"type":"string","description":"message context"},"messageValue":{"type":"string","description":" message"}}}}}}
```

## DELETE /cmn/users/me/seen-messages

> delete all seen messages

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"User Message","description":"the user message API"}],"servers":[{"url":"api.example.com"}],"paths":{"/cmn/users/me/seen-messages":{"delete":{"tags":["User Message"],"summary":"delete all seen messages","operationId":"deleteMySeenMessages","responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/core-api-OperationMessage"}}}}}}}},"components":{"schemas":{"core-api-OperationMessage":{"properties":{"context":{"type":"string","description":"message context"},"messageValue":{"type":"string","description":" message"}}}}}}
```

## DELETE /cmn/users/me/all-messages

> delete all messages

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"User Message","description":"the user message API"}],"servers":[{"url":"api.example.com"}],"paths":{"/cmn/users/me/all-messages":{"delete":{"tags":["User Message"],"summary":"delete all messages","operationId":"deleteMyMessages","responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/core-api-OperationMessage"}}}}}}}},"components":{"schemas":{"core-api-OperationMessage":{"properties":{"context":{"type":"string","description":"message context"},"messageValue":{"type":"string","description":" message"}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://developer.vario-software.de/api-reference/user-message.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
